"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable-next-line
var octokitGetNextPage = require('octokit-pagination-methods/lib/get-next-page');
// tslint:disable-next-line
var octokitHasNextPage = require('octokit-pagination-methods/lib/has-next-page');
function addPagination(octokit) {
    var octokitPaginate = octokit.paginate;
    octokit.paginate = Object.assign(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return paginate(octokit, octokitPaginate, args[0], args[1], args[2]);
    }, { iterator: octokit.paginate.iterator });
}
exports.addPagination = addPagination;
var defaultCallback = function (response, done) { return response; };
function paginate(octokit, octokitPaginate) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    return __awaiter(this, void 0, void 0, function () {
        var responsePromise, callback, collection, getNextPage, done, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Until we fully deprecate the old paginate method, we need to check if the
                    // first argument. If it is a promise we return the old function signature
                    if (!args[0].then) {
                        return [2 /*return*/, octokitPaginate(args[0], args[1], args[2])];
                    }
                    responsePromise = args[0];
                    callback = args[1] || defaultCallback;
                    // Deprecated since 8.0.0
                    // tslint:disable-next-line:no-console
                    console.warn(new Error(".paginate(promise) is deprecated. Use .paginate(endpointOptions) instead.\n\nFor example, instead of\n\n    context.github.paginate(context.github.issues.getAll(context.repo())\n\ndo\n\n    context.github.paginate(context.github.issues.getAll.endpoint.merge(context.repo())\n\nNote that when using the new syntax, the responses will be mapped to its data only by default.\n\nSee https://probot.github.io/docs/pagination/"));
                    collection = [];
                    getNextPage = true;
                    done = function () {
                        getNextPage = false;
                    };
                    return [4 /*yield*/, responsePromise];
                case 1:
                    response = _a.sent();
                    collection = collection.concat(callback(response, done));
                    _a.label = 2;
                case 2:
                    if (!(getNextPage && octokitHasNextPage(response))) return [3 /*break*/, 4];
                    return [4 /*yield*/, octokitGetNextPage(octokit, response)];
                case 3:
                    response = _a.sent();
                    collection = collection.concat(callback(response, done));
                    return [3 /*break*/, 2];
                case 4: return [2 /*return*/, collection];
            }
        });
    });
}
//# sourceMappingURL=pagination.js.map